## healpy 1.16.1

=== cfitsio/CMakeLists.txt ===
#==============================================================================
# CFITSIO CMakeLists.txt
#==============================================================================

# Ensure that build directory is not the source directory:
IF(${CMAKE_SOURCE_DIR} STREQUAL ${CMAKE_BINARY_DIR})
	message(FATAL_ERROR
		"Please create a separate directory for building CFITSIO."
		)
ENDIF()

CMAKE_MINIMUM_REQUIRED(VERSION 3.1)

# Suppress warning about WIN32 no longer being defined on Cygwin:
SET(CMAKE_LEGACY_CYGWIN_WIN32 0)

PROJECT(CFITSIO
	DESCRIPTION "Library of C and Fortran subroutines for reading and writing data files in FITS data format."
	LANGUAGES C CXX
	)

# Define project version
SET(${PROJECT_NAME}_MAJOR 4)
SET(${PROJECT_NAME}_MINOR 1)
SET(${PROJECT_NAME}_MICRO 0)
SET(${PROJECT_NAME}_VERSION ${${PROJECT_NAME}_MAJOR}.${${PROJECT_NAME}_MINOR}.${${PROJECT_NAME}_MICRO})
SET(LIB_NAME cfitsio)

# Allow @rpath token in target install name on Macs.
# See "cmake --help-policy CMP0042" for more information.
IF(POLICY CMP0042)
  CMAKE_POLICY(SET CMP0042 NEW)
ENDIF()

INCLUDE(CheckLibraryExists)
INCLUDE(CheckFunctionExists)
INCLUDE(CheckSymbolExists)
INCLUDE(CheckCSourceCompiles)

#==============================================================================
# Build options:
#==============================================================================

# Allow the developer to select if Dynamic or Static libraries are built
OPTION(BUILD_SHARED_LIBS "Build Shared Libraries" ON)

# Allow curl dependency to be disabled with "-DUSE_CURL=OFF":
OPTION(USE_CURL "USE_CURL" ON)

OPTION(USE_PTHREADS "Thread-safe build (using pthreads)" OFF)

OPTION(TESTS "Build test programs Testprog and cookbook" OFF)

OPTION(UTILS "Build FPack, Funpack, and Fitscopy executables" OFF)

OPTION(USE_SSE2 "Enable use of instructions in the SSE2 extended instruction set" OFF)

OPTION(USE_SSSE3 "Enable use of instructions in the SSSE3 extended instruction set" OFF)

IF(NOT WIN32)
    OPTION(USE_BZIP2 "Enable bzip2 support" OFF)
ENDIF()

#==============================================================================

FIND_PACKAGE(ZLIB REQUIRED)

IF(BUILD_SHARED_LIBS)
  SET (LIB_TYPE SHARED)
ELSE()
  SET (LIB_TYPE STATIC)
ENDIF(BUILD_SHARED_LIBS)

IF(NOT WIN32)
   # Find curl library, for HTTPS support:
   IF(USE_CURL)
      FIND_PACKAGE(CURL)
      IF(CURL_FOUND)
         ADD_DEFINITIONS(-DCFITSIO_HAVE_CURL)
      ENDIF()
   ENDIF()
ENDIF(NOT WIN32)

IF(USE_PTHREADS)
   FIND_PACKAGE(Threads REQUIRED)
   ADD_DEFINITIONS(-D_REENTRANT)
ENDIF(USE_PTHREADS)

IF(USE_BZIP2)
   FIND_PACKAGE(BZip2 REQUIRED)
   ADD_DEFINITIONS(-DHAVE_BZIP2=1)
ENDIF(USE_BZIP2)

# Math library (not available in MSVC or MINGW)
IF(MSVC OR MINGW)
   SET(M_LIB "")
ELSE()
   FIND_LIBRARY(M_LIB m)
ENDIF()

# Support for remote file drivers is not implemented for native Windows:
IF (NOT MSVC)

    # Find library needed for gethostbyname:
    CHECK_FUNCTION_EXISTS("gethostbyname" CMAKE_HAVE_GETHOSTBYNAME)
    IF (NOT CMAKE_HAVE_GETHOSTBYNAME)
        CHECK_LIBRARY_EXISTS("nsl" "gethostbyname" "" CMAKE_HAVE_GETHOSTBYNAME)
    ENDIF ()

    # Find library needed for connect:
    CHECK_FUNCTION_EXISTS("connect" CMAKE_HAVE_CONNECT)
    IF (NOT CMAKE_HAVE_CONNECT)
        CHECK_LIBRARY_EXISTS("socket" "connect" "" CMAKE_HAVE_CONNECT)
    ENDIF ()

    # Define HAVE_NET_SERVICES if gethostbyname & connect were found:
    IF (CMAKE_HAVE_GETHOSTBYNAME AND CMAKE_HAVE_CONNECT)
        ADD_DEFINITIONS(-DHAVE_NET_SERVICES)
        CHECK_SYMBOL_EXISTS(fmemopen "stdio.h" HAVE_FMEMOPEN)
        IF(HAVE_FMEMOPEN)
            ADD_DEFINITIONS(-DHAVE_FMEMOPEN)
        ENDIF()
    ENDIF()

ENDIF()

IF(MSVC OR BORLAND)
    # Define
    ADD_DEFINITIONS(-D_CRT_SECURE_NO_DEPRECATE)
    # Need an empty unistd.h in MSVC for flex-generated eval_l.c:
    FILE(WRITE ${CMAKE_SOURCE_DIR}/unistd.h "")
    INCLUDE_DIRECTORIES(${CMAKE_SOURCE_DIR})
ENDIF()

IF(BORLAND)
    # Suppress spurious Borland compiler warnings about "Suspicious
    # pointer arithmetic", "Possibly incorrect assignment", and
    # "Comparing signed and unsigned values".
    ADD_DEFINITIONS(-w-spa)
    ADD_DEFINITIONS(-w-pia)
    ADD_DEFINITIONS(-w-csu)
ENDIF()

IF(USE_SSE2)
    IF("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU" OR
       "${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang" OR
       "${CMAKE_CXX_COMPILER_ID}" STREQUAL "AppleClang")
        ADD_COMPILE_OPTIONS(-msse2)
    ENDIF()
    IF(MSVC)
        ADD_DEFINITIONS(-D__SSE2__=1)
    ENDIF()
ENDIF()

IF(USE_SSSE3)
    IF("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU" OR
       "${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang" OR
       "${CMAKE_CXX_COMPILER_ID}" STREQUAL "AppleClang")
        ADD_COMPILE_OPTIONS(-mssse3)
    ENDIF()
    IF(MSVC)
        ADD_DEFINITIONS(-D__SSE2__=1 -D__SSSE3__=1)
    ENDIF()
ENDIF()

# Test for the unix ftruncate function
CHECK_SYMBOL_EXISTS(ftruncate "unistd.h" HAVE_FTRUNCATE)
IF(HAVE_FTRUNCATE)
    ADD_DEFINITIONS(-DHAVE_UNISTD_H -DHAVE_FTRUNCATE)
ENDIF()

# Check is System V IPC is supported on this machine
CHECK_C_SOURCE_COMPILES("
#include <sys/ipc.h>
#include <sys/shm.h>
#include <sys/sem.h>
int main() {
  shmat(0,0,0);
  shmdt(0);
  shmget(0, 0, 0);
  semget(0, 0, 0);
  return 0;
}" HAVE_SHMEM_SERVICES)
IF(HAVE_SHMEM_SERVICES)
    ADD_DEFINITIONS(-DHAVE_SHMEM_SERVICES)

    # Some systems define flock_t, for others we have to define it ourselves
    CHECK_C_SOURCE_COMPILES("
    #include <sys/flock.h>
    int main() {
      flock_t filler;
      return 0;
    }" HAVE_FLOCK_T)
    IF(HAVE_FLOCK_T)
        ADD_DEFINITIONS(-DHAVE_FLOCK_T)
    ENDIF()

    # Check union semun
    CHECK_C_SOURCE_COMPILES("
    #include <sys/ipc.h>
    #include <sys/shm.h>
    #include <sys/sem.h>
    int main() {
      union semun filler;
      return 0;
    }" HAVE_UNION_SEMUN)
    IF(HAVE_UNION_SEMUN)
        ADD_DEFINITIONS(-DHAVE_UNION_SEMUN)
    ENDIF()
ENDIF()

IF(WIN32 AND BUILD_SHARED_LIBS)
    ADD_DEFINITIONS(-Dcfitsio_EXPORTS)
ENDIF()

#==============================================================================
# CFITSIO source code:
#==============================================================================

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}")
set (LIB_DESTINATION "${CMAKE_INSTALL_PREFIX}/lib${LIB_SUFFIX}")
set (INCLUDE_INSTALL_DIR "${CMAKE_INSTALL_PREFIX}/include/")
set (BIN_DESTINATION "${CMAKE_INSTALL_PREFIX}/bin")

SET(H_FILES fitsio.h fitsio2.h longnam.h)

SET(SRC_FILES
    buffers.c cfileio.c checksum.c
    drvrfile.c drvrmem.c drvrnet.c drvrsmem.c
    editcol.c edithdu.c eval_f.c eval_l.c eval_y.c
    f77_wrap1.c f77_wrap2.c f77_wrap3.c f77_wrap4.c
    fits_hcompress.c fits_hdecompress.c fitscore.c
    getcol.c getcolb.c getcold.c getcole.c getcoli.c getcolj.c getcolk.c
    getcoll.c getcols.c getcolsb.c getcolui.c getcoluj.c getcoluk.c
    getkey.c group.c grparser.c histo.c imcompress.c iraffits.c modkey.c
    pliocomp.c
    putcol.c putcolb.c putcold.c putcole.c putcoli.c putcolj.c putcolk.c
    putcoll.c putcols.c putcolsb.c putcolu.c putcolui.c putcoluj.c putcoluk.c
    putkey.c quantize.c region.c ricecomp.c scalnull.c simplerng.c swapproc.c
    wcssub.c wcsutil.c zcompress.c zuncompress.c
)

# For future modifications:

# drvrsmem.c is only usable if HAVE_SHMEM_SERVICES is defined:
#drvrsmem.c

# drvrgsiftp.c is only usable if HAVE_NET_SERVICES & HAVE_GSIFTP are defined:
#drvrgsiftp.c

#==============================================================================
# Add libraries:
#==============================================================================
ADD_LIBRARY(${LIB_NAME} ${LIB_TYPE} ${H_FILES} ${SRC_FILES})
# Math:
TARGET_LINK_LIBRARIES(${LIB_NAME} ${M_LIB})
# zlib:
IF (ZLIB_FOUND)
    TARGET_INCLUDE_DIRECTORIES(${LIB_NAME} PUBLIC ${ZLIB_INCLUDE_DIR})
    TARGET_LINK_LIBRARIES(${LIB_NAME} ${ZLIB_LIBRARIES})
    # For cfitsio.pc.cmake:
    SET (PKG_CONFIG_LIBS "${PKG_CONFIG_LIBS} -lz")
ENDIF(ZLIB_FOUND)
# cURL:
IF (CURL_FOUND)
    TARGET_INCLUDE_DIRECTORIES(${LIB_NAME} PUBLIC ${CURL_INCLUDE_DIRS})
    TARGET_LINK_LIBRARIES(${LIB_NAME} ${CURL_LIBRARIES})
    # For cfitsio.pc.cmake:
    SET (PKG_CONFIG_LIBS "${PKG_CONFIG_LIBS} -lcurl")
ENDIF(CURL_FOUND)
# PThreads:
IF (THREADS_FOUND)
    TARGET_LINK_LIBRARIES(${LIB_NAME} Threads::Threads)
ENDIF(THREADS_FOUND)
# BZip2:
IF (BZIP2_FOUND)
    TARGET_INCLUDE_DIRECTORIES(${LIB_NAME} PUBLIC ${BZIP2_INCLUDE_DIRS})
    TARGET_LINK_LIBRARIES(${LIB_NAME} ${BZIP2_LIBRARIES})
    SET (PKG_CONFIG_LIBS "${PKG_CONFIG_LIBS} -lbz2")
ENDIF(BZIP2_FOUND)

SET_TARGET_PROPERTIES(${LIB_NAME} PROPERTIES VERSION ${${PROJECT_NAME}_VERSION} SOVERSION ${${PROJECT_NAME}_MAJOR})
include(GNUInstallDirs)
install(TARGETS ${LIB_NAME}
        RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
        LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
        ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
)
install(FILES ${H_FILES} DESTINATION ${INCLUDE_INSTALL_DIR} COMPONENT Devel)

#==============================================================================
# Optional test programs:
#==============================================================================
IF (TESTS)

    ENABLE_TESTING()

    ADD_EXECUTABLE(TestProg testprog.c)
    TARGET_LINK_LIBRARIES(TestProg ${LIB_NAME})
    ADD_TEST(TestProg TestProg)
    # Copy testprog.tpt to build directory to allow quick test
    # of ./TestProg (or .\Release\TestProg.exe in MSVC):
    FILE(COPY ${CMAKE_SOURCE_DIR}/testprog.tpt DESTINATION ${CMAKE_CURRENT_BINARY_DIR})

    ADD_EXECUTABLE(cookbook cookbook.c)
    TARGET_LINK_LIBRARIES(cookbook ${LIB_NAME})
    ADD_TEST(cookbook cookbook)

ENDIF(TESTS)

#==============================================================================
# Optional utilities:
#==============================================================================
IF (UTILS)

    ADD_EXECUTABLE(FPack fpack.c fpackutil.c)
    TARGET_LINK_LIBRARIES(FPack ${LIB_NAME})

    ADD_EXECUTABLE(Funpack funpack.c fpackutil.c)
    TARGET_LINK_LIBRARIES(Funpack ${LIB_NAME})

    ADD_EXECUTABLE(Fitscopy fitscopy.c)
    TARGET_LINK_LIBRARIES(Fitscopy ${LIB_NAME})

    # To expand the command line arguments in Windows, see:
    # http://msdn.microsoft.com/en-us/library/8bch7bkk.aspx
    if(MSVC)
      set_target_properties(FPack Funpack PROPERTIES LINK_FLAGS "setargv.obj")
    endif(MSVC)

    install(TARGETS FPack Funpack Fitscopy RUNTIME DESTINATION bin)

ENDIF(UTILS)

#==============================================================================
# cfitsio.pc
#==============================================================================
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/cfitsio.pc.cmake ${CMAKE_CURRENT_BINARY_DIR}/cfitsio.pc @ONLY)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/cfitsio.pc DESTINATION lib/pkgconfig/)

=== debian/changelog ===
healpy (1.16.1-1) unstable; urgency=medium

  * New upstream version 1.16.1
  * Push Standards-Version to 4.6.1. No changes needed.
  * Remove unneeded python3-six build dependency
  * Import setuptools before distutils setuptools for Cython compatibility
    (Closes: #1022486)

 -- Ole Streicher <olebole@debian.org>  Tue, 01 Nov 2022 15:44:46 +0100

=== debian/control ===
Source: healpy
Priority: optional
Maintainer: Debian Astro Team <debian-astro-maintainers@lists.alioth.debian.org>
Uploaders: Leo Singer <leo.singer@ligo.org>
Homepage: http://healpy.readthedocs.org
Section: python
Build-Depends:
 cython3,
 python3-setuptools,
 python3-all-dev,
 python3-matplotlib,
 python3-numpy,
 python3-astropy,
 python3-pytest,
 python3-pytest-cython,
 python3-pytest-doctestplus,
 python3-pytest-runner,
 python3-scipy,
 debhelper-compat (= 13),
 dh-python,
 libcfitsio-dev,
 libsharp-dev,
 libhealpix-cxx-dev (>= 3.80.0-4),
 pkg-config
Rules-Requires-Root: no
Vcs-Git: https://salsa.debian.org/debian-astro-team/healpy.git
Vcs-Browser: https://salsa.debian.org/debian-astro-team/healpy
Standards-Version: 4.6.1

Package: healpy-data
Provides: python-healpy-data
Replaces: python-healpy-data
Conflicts: python-healpy-data
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: HEALPix representation of spherical data - Python data
 HEALPix is an acronym for Hierarchical Equal Area isoLatitude Pixelization
 of a sphere. As suggested in the name, this pixelization produces a
 subdivision of a spherical surface in which each pixel covers the same
 surface area as every other pixel. It is commonly used to store all-sky
 astronomical images, most famously maps of the cosmic microwave background.
 .
 This package provides platform-independent data and test files for the Python
 wrapper around the C++ implementation of HEALPix.


Package: python3-healpy
Architecture: any
Depends:
 ${misc:Depends}, ${python3:Depends}, ${shlibs:Depends},
 python3-astropy, python3-matplotlib, python3-numpy, python3-scipy,
 healpy-data
Description: HEALPix representation of spherical data - Python3 interface
 HEALPix is an acronym for Hierarchical Equal Area isoLatitude Pixelization
 of a sphere. As suggested in the name, this pixelization produces a
 subdivision of a spherical surface in which each pixel covers the same
 surface area as every other pixel. It is commonly used to store all-sky
 astronomical images, most famously maps of the cosmic microwave background.
 .
 This package provides a Python3 wrapper around the C++ implementation of
 HEALPix.

## healpy 1.16.6

=== debian/changelog ===
healpy (1.16.6-2) unstable; urgency=medium

  * Team upload.
  * d/rules: skip two doctests on i386 due to minute rounding errors.
  * d/control: pkg-config is now pkgconf.
  * t/tests/python3-healpy: always skip the 2 broken doctests from
    above.
  * Build-Depends: s/dh-python/dh-sequence-python3/ (routine-update)
  Use secure URI in Homepage field.

 -- Michael R. Crusoe <crusoe@debian.org>  Thu, 28 Mar 2024 13:35:19 +0100

healpy (1.16.6-1) unstable; urgency=medium

  * Team upload.
  * New upstream version 1.16.6. Closes: #1056805
  * Rediff patches
  * Push Standards-Verson to 4.6.2. No changes needed.
  * Replace Upstream-Source with Source in d/copyright
  * Remove leading slash in d/install
  * Add new python3-setuptools-scm build dependency

 -- Ole Streicher <olebole@debian.org>  Wed, 27 Dec 2023 17:54:47 +0100

=== debian/control ===
Source: healpy
Maintainer: Debian Astro Team <debian-astro-maintainers@lists.alioth.debian.org>
Uploaders: Leo Singer <leo.singer@ligo.org>
Section: python
Priority: optional
Build-Depends: cython3,
               python3-setuptools,
               python3-setuptools-scm,
               python3-all-dev,
               python3-matplotlib,
               python3-numpy,
               python3-astropy,
               python3-pytest,
               python3-pytest-cython,
               python3-pytest-doctestplus,
               python3-pytest-runner,
               python3-scipy,
               debhelper-compat (= 13),
               dh-sequence-python3,
               libcfitsio-dev,
               libsharp-dev,
               libhealpix-cxx-dev (>= 3.80.0-4),
               pkgconf
Standards-Version: 4.6.2
Vcs-Browser: https://salsa.debian.org/debian-astro-team/healpy
Vcs-Git: https://salsa.debian.org/debian-astro-team/healpy.git
Homepage: https://healpy.readthedocs.org
Rules-Requires-Root: no

Package: healpy-data
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Conflicts: python-healpy-data
Provides: python-healpy-data
Replaces: python-healpy-data
Description: HEALPix representation of spherical data - Python data
 HEALPix is an acronym for Hierarchical Equal Area isoLatitude Pixelization
 of a sphere. As suggested in the name, this pixelization produces a
 subdivision of a spherical surface in which each pixel covers the same
 surface area as every other pixel. It is commonly used to store all-sky
 astronomical images, most famously maps of the cosmic microwave background.
 .
 This package provides platform-independent data and test files for the Python
 wrapper around the C++ implementation of HEALPix.

Package: python3-healpy
Architecture: any
Depends: ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends},
         python3-astropy,
         python3-matplotlib,
         python3-numpy,
         python3-scipy,
         healpy-data
Description: HEALPix representation of spherical data - Python3 interface
 HEALPix is an acronym for Hierarchical Equal Area isoLatitude Pixelization
 of a sphere. As suggested in the name, this pixelization produces a
 subdivision of a spherical surface in which each pixel covers the same
 surface area as every other pixel. It is commonly used to store all-sky
 astronomical images, most famously maps of the cosmic microwave background.
 .
 This package provides a Python3 wrapper around the C++ implementation of
 HEALPix.

=== debian/rules ===
#!/usr/bin/make -f

export PYBUILD_NAME=healpy
export PYBUILD_TEST_ARGS=--doctest-modules
ifeq (i386,$(DEB_HOST_ARCH))
export PYBUILD_TEST_ARGS=-k "not (healpy.pixelfunc.nside2pixarea or healpy.pixelfunc.nside2resol)"
#rounding error
endif

# Enable build hardening
export DEB_BUILD_MAINT_OPTIONS = hardening=+bindnow
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

%:
	dh $@ --buildsystem=pybuild

execute_after_dh_shlibdeps:
	dh_numpy3

matplotlibrc:
	echo backend: agg > $@

override_dh_auto_test: matplotlibrc
	PYTHONDONTWRITEBYTECODE=yes dh_auto_test

# After installing, remove data directories that we will replace with symlinks
execute_after_dh_install:
	rm -rf debian/python*-healpy/usr/lib/python*/dist-packages/healpy/data debian/python*-healpy/usr/lib/python*/dist-packages/healpy/test/data

# Fix permissions on data files
execute_before_dh_fixperms-indep:
	find debian/healpy-data/usr/share/healpy -type f | xargs chmod -x

## healpy 1.18.0

=== debian/changelog ===
healpy (1.18.0-1build2) plucky; urgency=medium

  * No-change rebuild with Python 3.13 only

 -- Graham Inggs <ginggs@ubuntu.com>  Tue, 04 Mar 2025 15:49:02 +0000

healpy (1.18.0-1build1) plucky; urgency=medium

  * No-change rebuild against python3-numpy2-abi0

 -- Graham Inggs <ginggs@ubuntu.com>  Fri, 31 Jan 2025 09:36:12 +0000

healpy (1.18.0-1) unstable; urgency=medium

  * New upstream release. Closes: #1079675
  * Rediff patches.
  * Update Standards-Version to 4.7.0.

 -- Leo Singer <leo.singer@ligo.org>  Thu, 05 Dec 2024 22:39:47 -0500

=== debian/control ===
--- 
+++ 
@@ -13,15 +13,14 @@
                python3-pytest,
                python3-pytest-cython,
                python3-pytest-doctestplus,
-               python3-pytest-runner,
                python3-scipy,
                debhelper-compat (= 13),
                dh-sequence-python3,
                libcfitsio-dev,
                libsharp-dev,
-               libhealpix-cxx-dev (>= 3.80.0-4),
+               libhealpix-cxx-dev (>= 3.83.0),
                pkgconf
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Vcs-Browser: https://salsa.debian.org/debian-astro-team/healpy
 Vcs-Git: https://salsa.debian.org/debian-astro-team/healpy.git
 Homepage: https://healpy.readthedocs.org

=== debian/tests/control ===
Tests: python3-healpy
Depends: @, python3-pytest, python3-pytest-cython, python3-pytest-doctestplus

## healpy 1.18.1

=== cextern/cfitsio/CMakeLists.txt ===
#==============================================================================
# CFITSIO CMakeLists.txt
#==============================================================================

# Ensure that build directory is not the source directory:
IF(${CMAKE_SOURCE_DIR} STREQUAL ${CMAKE_BINARY_DIR})
	message(FATAL_ERROR
		"Please create a separate directory for building CFITSIO."
		)
ENDIF()

CMAKE_MINIMUM_REQUIRED(VERSION 3.1)

# Suppress warning about WIN32 no longer being defined on Cygwin:
SET(CMAKE_LEGACY_CYGWIN_WIN32 0)

PROJECT(CFITSIO
	DESCRIPTION "Library of C and Fortran subroutines for reading and writing data files in FITS data format."
	LANGUAGES C CXX
	)

set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_INCLUDE_CURRENT_DIR_IN_INTERFACE ON)

# Define project version
SET(${PROJECT_NAME}_SONAME 10)
SET(${PROJECT_NAME}_MAJOR 4)
SET(${PROJECT_NAME}_MINOR 6)
SET(${PROJECT_NAME}_MICRO 2)
SET(${PROJECT_NAME}_VERSION ${${PROJECT_NAME}_MAJOR}.${${PROJECT_NAME}_MINOR}.${${PROJECT_NAME}_MICRO})
SET(LIB_NAME cfitsio)

# Allow @rpath token in target install name on Macs.
# See "cmake --help-policy CMP0042" for more information.
IF(POLICY CMP0042)
  CMAKE_POLICY(SET CMP0042 NEW)
ENDIF()

INCLUDE(CheckLibraryExists)
INCLUDE(CheckFunctionExists)
INCLUDE(CheckSymbolExists)
INCLUDE(CheckCSourceCompiles)
INCLUDE(GNUInstallDirs)

#==============================================================================
# Build options:
#==============================================================================

# Allow the developer to select if Dynamic or Static libraries are built
OPTION(BUILD_SHARED_LIBS "Build Shared Libraries" ON)

# Allow curl dependency to be disabled with "-DUSE_CURL=OFF":
OPTION(USE_CURL "USE_CURL" ON)

OPTION(USE_PTHREADS "Thread-safe build (using pthreads)" OFF)

OPTION(TESTS "Build test programs Testprog and cookbook" ON)

OPTION(UTILS "Build helper programs [fpack, funpack, fitscopy, fitsverify, imcopy, smem, speed]" ON)

OPTION(USE_SSE2 "Enable use of instructions in the SSE2 extended instruction set" OFF)

OPTION(USE_SSSE3 "Enable use of instructions in the SSSE3 extended instruction set" OFF)

OPTION(USE_BZIP2 "Enable bzip2 support" OFF)

#==============================================================================

FIND_PACKAGE(ZLIB REQUIRED)

IF(BUILD_SHARED_LIBS)
  SET (LIB_TYPE SHARED)
ELSE()
  SET (LIB_TYPE STATIC)
ENDIF(BUILD_SHARED_LIBS)

# Find curl library, for HTTPS support:
IF(USE_CURL)
   FIND_PACKAGE(CURL)
   IF(CURL_FOUND)
      ADD_DEFINITIONS(-DCFITSIO_HAVE_CURL)
   ENDIF()
ENDIF()

IF(USE_PTHREADS)
   FIND_PACKAGE(Threads REQUIRED)
   ADD_DEFINITIONS(-D_REENTRANT)
ENDIF(USE_PTHREADS)

IF(USE_BZIP2)
   FIND_PACKAGE(BZip2 REQUIRED)
   ADD_DEFINITIONS(-DHAVE_BZIP2=1)
ENDIF(USE_BZIP2)

# Math library (not available in MSVC or MINGW)
IF(MSVC OR MINGW)
   SET(M_LIB "")
ELSE()
   FIND_LIBRARY(M_LIB m)
ENDIF()

# Support for remote file drivers is not implemented for native Windows:
IF (NOT MSVC)

    # Find library needed for gethostbyname:
    CHECK_FUNCTION_EXISTS("gethostbyname" CMAKE_HAVE_GETHOSTBYNAME)
    IF (NOT CMAKE_HAVE_GETHOSTBYNAME)
        CHECK_LIBRARY_EXISTS("nsl" "gethostbyname" "" CMAKE_HAVE_GETHOSTBYNAME)
    ENDIF ()

    # Find library needed for connect:
    CHECK_FUNCTION_EXISTS("connect" CMAKE_HAVE_CONNECT)
    IF (NOT CMAKE_HAVE_CONNECT)
        CHECK_LIBRARY_EXISTS("socket" "connect" "" CMAKE_HAVE_CONNECT)
    ENDIF ()

    # Define HAVE_NET_SERVICES if gethostbyname & connect were found:
    IF (CMAKE_HAVE_GETHOSTBYNAME AND CMAKE_HAVE_CONNECT)
        ADD_DEFINITIONS(-DHAVE_NET_SERVICES)
        CHECK_SYMBOL_EXISTS(fmemopen "stdio.h" HAVE_FMEMOPEN)
        IF(HAVE_FMEMOPEN)
            ADD_DEFINITIONS(-DHAVE_FMEMOPEN)
        ENDIF()
    ENDIF()

ENDIF()

IF(MSVC OR BORLAND)
    # Define
    ADD_DEFINITIONS(-D_CRT_SECURE_NO_DEPRECATE)
    # Need an empty unistd.h in MSVC for flex-generated eval_l.c:
    FILE(WRITE ${CMAKE_SOURCE_DIR}/unistd.h "")
    INCLUDE_DIRECTORIES(${CMAKE_SOURCE_DIR})
ENDIF()

IF(BORLAND)
    # Suppress spurious Borland compiler warnings about "Suspicious
    # pointer arithmetic", "Possibly incorrect assignment", and
    # "Comparing signed and unsigned values".
    ADD_DEFINITIONS(-w-spa)
    ADD_DEFINITIONS(-w-pia)
    ADD_DEFINITIONS(-w-csu)
ENDIF()

IF(USE_SSE2)
    IF("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU" OR
       "${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang" OR
       "${CMAKE_CXX_COMPILER_ID}" STREQUAL "AppleClang")
        ADD_COMPILE_OPTIONS(-msse2)
    ENDIF()
    IF(MSVC)
        ADD_DEFINITIONS(-D__SSE2__=1)
    ENDIF()
ENDIF()

IF(USE_SSSE3)
    IF("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU" OR
       "${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang" OR
       "${CMAKE_CXX_COMPILER_ID}" STREQUAL "AppleClang")
        ADD_COMPILE_OPTIONS(-mssse3)
    ENDIF()
    IF(MSVC)
        ADD_DEFINITIONS(-D__SSE2__=1 -D__SSSE3__=1)
    ENDIF()
ENDIF()

# Test for the unix ftruncate function
CHECK_SYMBOL_EXISTS(ftruncate "unistd.h" HAVE_FTRUNCATE)
IF(HAVE_FTRUNCATE)
    ADD_DEFINITIONS(-DHAVE_UNISTD_H -DHAVE_FTRUNCATE)
ENDIF()

# Check is System V IPC is supported on this machine
CHECK_C_SOURCE_COMPILES("
#include <sys/ipc.h>
#include <sys/shm.h>
#include <sys/sem.h>
int main() {
  shmat(0,0,0);
  shmdt(0);
  shmget(0, 0, 0);
  semget(0, 0, 0);
  return 0;
}" HAVE_SHMEM_SERVICES)
IF(HAVE_SHMEM_SERVICES)
    ADD_DEFINITIONS(-DHAVE_SHMEM_SERVICES)

    # Some systems define flock_t, for others we have to define it ourselves
    CHECK_C_SOURCE_COMPILES("
    #include <sys/flock.h>
    int main() {
      flock_t filler;
      return 0;
    }" HAVE_FLOCK_T)
    IF(HAVE_FLOCK_T)
        ADD_DEFINITIONS(-DHAVE_FLOCK_T)
    ENDIF()

    # Check union semun
    CHECK_C_SOURCE_COMPILES("
    #include <sys/ipc.h>
    #include <sys/shm.h>
    #include <sys/sem.h>
    int main() {
      union semun filler;
      return 0;
    }" HAVE_UNION_SEMUN)
    IF(HAVE_UNION_SEMUN)
        ADD_DEFINITIONS(-DHAVE_UNION_SEMUN)
    ENDIF()
ENDIF()

IF(WIN32 AND BUILD_SHARED_LIBS)
    ADD_DEFINITIONS(-Dcfitsio_EXPORTS)
ENDIF()

#==============================================================================
# CFITSIO source code:
#==============================================================================

include(GenerateExportHeader)

SET(H_FILES fitsio.h fitsio2.h longnam.h)

SET(SRC_FILES
    buffers.c cfileio.c checksum.c
    drvrfile.c drvrmem.c drvrnet.c drvrsmem.c
    editcol.c edithdu.c eval_f.c eval_l.c eval_y.c
    f77_wrap1.c f77_wrap2.c f77_wrap3.c f77_wrap4.c
    fits_hcompress.c fits_hdecompress.c fitscore.c
    getcol.c getcolb.c getcold.c getcole.c getcoli.c getcolj.c getcolk.c
    getcoll.c getcols.c getcolsb.c getcolui.c getcoluj.c getcoluk.c
    getkey.c group.c grparser.c histo.c imcompress.c iraffits.c modkey.c
    pliocomp.c
    putcol.c putcolb.c putcold.c putcole.c putcoli.c putcolj.c putcolk.c
    putcoll.c putcols.c putcolsb.c putcolu.c putcolui.c putcoluj.c putcoluk.c
    putkey.c quantize.c region.c ricecomp.c scalnull.c simplerng.c swapproc.c
    wcssub.c wcsutil.c zcompress.c zuncompress.c
)

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}")

# For future modifications:

# drvrsmem.c is only usable if HAVE_SHMEM_SERVICES is defined:
#drvrsmem.c

# drvrgsiftp.c is only usable if HAVE_NET_SERVICES & HAVE_GSIFTP are defined:
#drvrgsiftp.c

#==============================================================================
# Add libraries:
#==============================================================================

ADD_LIBRARY(${LIB_NAME} ${LIB_TYPE} ${H_FILES} ${SRC_FILES})

# Math:
TARGET_LINK_LIBRARIES(${LIB_NAME} ${M_LIB})
# zlib:
IF (ZLIB_FOUND)
    TARGET_INCLUDE_DIRECTORIES(${LIB_NAME} PUBLIC ${ZLIB_INCLUDE_DIR})
    TARGET_LINK_LIBRARIES(${LIB_NAME} ${ZLIB_LIBRARIES})
    # For cfitsio.pc.cmake:
    SET (PKG_CONFIG_LIBS "${PKG_CONFIG_LIBS} -lz")
ENDIF(ZLIB_FOUND)
# cURL:
IF (CURL_FOUND)
    TARGET_INCLUDE_DIRECTORIES(${LIB_NAME} PUBLIC ${CURL_INCLUDE_DIRS})
    TARGET_LINK_LIBRARIES(${LIB_NAME} ${CURL_LIBRARIES})
    # For cfitsio.pc.cmake:
    SET (PKG_CONFIG_LIBS "${PKG_CONFIG_LIBS} -lcurl")
ENDIF(CURL_FOUND)
# PThreads:
IF (THREADS_FOUND)
    TARGET_LINK_LIBRARIES(${LIB_NAME} Threads::Threads)
ENDIF(THREADS_FOUND)
# BZip2:
IF (BZIP2_FOUND)
    TARGET_INCLUDE_DIRECTORIES(${LIB_NAME} PUBLIC ${BZIP2_INCLUDE_DIRS})
    TARGET_LINK_LIBRARIES(${LIB_NAME} ${BZIP2_LIBRARIES})
    SET (PKG_CONFIG_LIBS "${PKG_CONFIG_LIBS} -lbz2")
ENDIF(BZIP2_FOUND)

#==============================================================================

generate_export_header(cfitsio)
set_property(TARGET cfitsio PROPERTY VERSION ${CFITSIO_VERSION})
set_property(TARGET cfitsio PROPERTY SOVERSION 10)
set_property(TARGET cfitsio PROPERTY INTERFACE_cfitsio_MAJOR_VERSION ${${PROJECT_NAME}_MAJOR})
set_property(TARGET cfitsio APPEND PROPERTY
  COMPATIBLE_INTERFACE_STRING cfitsio_MAJOR_VERSION
)

install(TARGETS cfitsio EXPORT cfitsioTargets
  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
  ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
  INCLUDES DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
)

install(FILES ${H_FILES} "${CMAKE_CURRENT_BINARY_DIR}/cfitsio_export.h"
  DESTINATION ${CMAKE_INSTALL_INCLUDEDIR} COMPONENT Devel)

include(CMakePackageConfigHelpers)
write_basic_package_version_file(
  "${CMAKE_CURRENT_BINARY_DIR}/cfitsio/cfitsioConfigVersion.cmake"
  VERSION ${CFITSIO_VERSION}
  COMPATIBILITY AnyNewerVersion
)

export(EXPORT cfitsioTargets
  FILE "${CMAKE_CURRENT_BINARY_DIR}/cfitsio/cfitsioTargets.cmake"
  NAMESPACE CFITSIO::
)
configure_file(cmake/cfitsioConfig.cmake
  "${CMAKE_CURRENT_BINARY_DIR}/cfitsio/cfitsioConfig.cmake"
  COPYONLY
)

set(ConfigPackageLocation ${CMAKE_INSTALL_LIBDIR}/cmake/cfitsio)
install(EXPORT cfitsioTargets
  FILE
    cfitsioTargets.cmake
  NAMESPACE
    CFITSIO::
  DESTINATION
    ${ConfigPackageLocation}
)
install(
  FILES
    cmake/cfitsioConfig.cmake
    "${CMAKE_CURRENT_BINARY_DIR}/cfitsio/cfitsioConfigVersion.cmake"
  DESTINATION
    ${ConfigPackageLocation}
  COMPONENT
    Devel
)

# cfitsio.pc:
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/cfitsio.pc.cmake ${CMAKE_CURRENT_BINARY_DIR}/cfitsio.pc @ONLY)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/cfitsio.pc DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)

#==============================================================================
# Test programs:
#==============================================================================
IF (TESTS)

    ENABLE_TESTING()

    ADD_EXECUTABLE(TestProg utilities/testprog.c)
    TARGET_LINK_LIBRARIES(TestProg ${LIB_NAME})
    ADD_TEST(TestProg TestProg)
    # Copy testprog.tpt to build directory to allow quick test
    # of ./TestProg (or .\Release\TestProg.exe in MSVC):
    FILE(COPY ${CMAKE_SOURCE_DIR}/testprog.tpt DESTINATION ${CMAKE_CURRENT_BINARY_DIR})

    ADD_EXECUTABLE(cookbook utilities/cookbook.c)
    TARGET_LINK_LIBRARIES(cookbook ${LIB_NAME})
    ADD_TEST(cookbook cookbook)

    install(TARGETS cookbook RUNTIME DESTINATION bin)

ENDIF(TESTS)

#==============================================================================
# Utilities:
#==============================================================================
IF (UTILS)

    ADD_EXECUTABLE(fpack utilities/fpack.c utilities/fpackutil.c)
    TARGET_LINK_LIBRARIES(fpack ${LIB_NAME})

    ADD_EXECUTABLE(funpack utilities/funpack.c utilities/fpackutil.c)
    TARGET_LINK_LIBRARIES(funpack ${LIB_NAME})

    ADD_EXECUTABLE(fitscopy utilities/fitscopy.c)
    TARGET_LINK_LIBRARIES(fitscopy ${LIB_NAME})

    ADD_EXECUTABLE(fitsverify
                  utilities/ftverify.c utilities/fvrf_data.c
                  utilities/fvrf_file.c utilities/fvrf_head.c
                  utilities/fvrf_key.c utilities/fvrf_misc.c)
    TARGET_COMPILE_DEFINITIONS(fitsverify PRIVATE -DSTANDALONE)
    TARGET_LINK_LIBRARIES(fitsverify ${LIB_NAME})

    ADD_EXECUTABLE(imcopy utilities/imcopy.c)

=== debian/changelog ===
healpy (1.18.1-2build1) resolute; urgency=medium

  * No-change rebuild with Python 3.14 as supported version

 -- Graham Inggs <ginggs@ubuntu.com>  Tue, 21 Oct 2025 17:44:12 +0000

healpy (1.18.1-2) unstable; urgency=medium

  * Team upload.
  * Update location of version.py in d/clean (Closes: #1101616, #1044796)

 -- Ole Streicher <olebole@debian.org>  Mon, 31 Mar 2025 18:18:47 +0200

healpy (1.18.1-1) unstable; urgency=medium

  * New upstream release. Closes: 1100222
  * Rediff patches.
  * Fix autopkgtest.
  * Don't install healpy_get_wmap_maps.sh script.
  * Update Standards-Version to 4.7.2.
  * Add missing build dependencies on python3-numpy-dev and
    pybuild-plugin-pyproject.

 -- Leo Singer <leo.singer@ligo.org>  Fri, 28 Mar 2025 10:42:28 -0400

=== debian/control ===
--- 
+++ 
@@ -4,11 +4,13 @@
 Section: python
 Priority: optional
 Build-Depends: cython3,
+               pybuild-plugin-pyproject,
                python3-setuptools,
                python3-setuptools-scm,
                python3-all-dev,
                python3-matplotlib,
                python3-numpy,
+               python3-numpy-dev,
                python3-astropy,
                python3-pytest,
                python3-pytest-cython,
@@ -20,7 +22,7 @@
                libsharp-dev,
                libhealpix-cxx-dev (>= 3.83.0),
                pkgconf
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Vcs-Browser: https://salsa.debian.org/debian-astro-team/healpy
 Vcs-Git: https://salsa.debian.org/debian-astro-team/healpy.git
 Homepage: https://healpy.readthedocs.org

=== debian/rules ===
--- 
+++ 
@@ -26,7 +26,7 @@
 
 # After installing, remove data directories that we will replace with symlinks
 execute_after_dh_install:
-	rm -rf debian/python*-healpy/usr/lib/python*/dist-packages/healpy/data debian/python*-healpy/usr/lib/python*/dist-packages/healpy/test/data
+	rm -rf debian/python*-healpy/usr/lib/python*/dist-packages/healpy/data
 
 # Fix permissions on data files
 execute_before_dh_fixperms-indep:

=== debian/tests/control ===
Tests: python3-healpy
# FIXME: remove python3-pkg-resources once
# https://github.com/lgpage/pytest-cython/pull/72 is fixed
Depends: @, python3-pytest, python3-pytest-cython, python3-pytest-doctestplus, python3-pkg-resources

=== debian/watch ===
version=4
https://pypi.debian.net/healpy/healpy-(\d+(?:\.\d+)*)\.(?:zip|tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))

## healpy 1.19.0

=== debian/changelog ===
healpy (1.19.0-2) unstable; urgency=medium

  * Team upload.
  * autopkgtest: remove dependency on python3-pkg-resources (Closes: #1125865)
  * Bump Standards-Version to 4.7.3, drop Priority: tag
  * Depends on fixed python3-pytest-cython
  * Fix syntax glitch in d/watch

 -- Alexandre Detiste <tchet@debian.org>  Tue, 10 Feb 2026 07:26:15 +0100

healpy (1.19.0-1) unstable; urgency=medium

  * New upstream release.

 -- Leo Singer <leo.singer@ligo.org>  Tue, 06 Jan 2026 20:50:39 -0500

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,6 @@
 Maintainer: Debian Astro Team <debian-astro-maintainers@lists.alioth.debian.org>
 Uploaders: Leo Singer <leo.singer@ligo.org>
 Section: python
-Priority: optional
 Build-Depends: cython3,
                pybuild-plugin-pyproject,
                python3-setuptools,
@@ -12,8 +11,9 @@
                python3-numpy,
                python3-numpy-dev,
                python3-astropy,
+               python3-requests,
                python3-pytest,
-               python3-pytest-cython,
+               python3-pytest-cython (>= 0.3.1-2~),
                python3-pytest-doctestplus,
                python3-scipy,
                debhelper-compat (= 13),
@@ -22,11 +22,10 @@
                libsharp-dev,
                libhealpix-cxx-dev (>= 3.83.0),
                pkgconf
-Standards-Version: 4.7.2
+Standards-Version: 4.7.3
 Vcs-Browser: https://salsa.debian.org/debian-astro-team/healpy
 Vcs-Git: https://salsa.debian.org/debian-astro-team/healpy.git
 Homepage: https://healpy.readthedocs.org
-Rules-Requires-Root: no
 
 Package: healpy-data
 Architecture: all

=== debian/tests/control ===
Tests: python3-healpy
Depends: @, python3-requests, python3-pytest, python3-pytest-cython (>= 0.3.1-2~), python3-pytest-doctestplus

=== debian/watch ===
Version: 5

Source: https://pypi.python.org/packages/source/h/healpy/
Matching-Pattern: healpy-@ANY_VERSION@@ARCHIVE_EXT@
